#version 330 core

in vec2 fUVs;

out vec3 color;

uniform sampler2D blurTexture;
uniform sampler2D depthBlurTexture;
uniform float deltaT;
uniform mat4 vpPrevious;
uniform mat4 vpInverse;

uniform vec3 blurPrevPosition;
uniform vec3 blurCurrentPosition;

void main(){

		int samples = 100;	
		float z = texture2D(depthBlurTexture, fUVs).r;
		float xDP = fUVs.x * 2 - 1;
		float yDP = (fUVs.y) * 2 - 1;
		vec4 vProjectedPos = vec4(xDP, yDP, z, 1);		
		vec4 vPositionVS = vProjectedPos * vpInverse;
		
		vec4 worldPos = vPositionVS/vPositionVS.w;
		vec4 currPos = vProjectedPos;
		
		vec4 prevPos = worldPos * vpPrevious;
		
		prevPos/=prevPos.w;
		
		//vec3 velocity = ((currPos - prevPos)/2.0).xyz;
		vec3 velocity = ((blurPrevPosition-blurCurrentPosition)/4).xyz;

		float mblurScale = (0.3/deltaT) / 60;
		velocity *= mblurScale;
		vec2 pixelVelocity = velocity.xz;
		pixelVelocity/=samples;
		
		vec4 texcolour = texture(blurTexture, fUVs);

		vec2 currentTexCoord = fUVs;
		
		vec4 result = texture(blurTexture, fUVs);
		
		for (int i=1; i<samples; ++i){
			currentTexCoord-=pixelVelocity;
			vec4 sampleColour = texture(blurTexture, currentTexCoord);
			texcolour += sampleColour;
						
			vec2 offset;// = pixelVelocity * (float(i) / float(samples-1)-0.5);
			result += texture(blurTexture, currentTexCoord + offset);
		}
		result/= float(samples);

		//vec4 finalColour = texcolour/samples;
		//color = vec3(finalColour.rgb);
		color = vec3(result.rgb);

}