#version 330

in vec3 worldspacePos;
in vec3 cameraspaceNorm;
in vec3 cameraspaceEyeDir;
in vec3 cameraspaceLightDir;

uniform vec3 worldspaceLight;
uniform sampler2D color_Texture;

in vec3 worldNorm;
in vec2 fUVs;
in float object; 

out vec4 color;

float exposure = 0.25;
float decay = 0.97;
float density = 0.97;
float weight = 0.5;

uniform vec2 lightPositionOnScreen;
uniform sampler2D firstPass;

const int NUM_SAMPLES = 100;


void main() {
		
		//Spot
		//vec3 lightColor = vec3(0.5, 0.5, 1);
		vec3 lightColor = vec3(0.5, 0.5, 0.5);
        float lightPower = 100.0f;//Lichtstrke

        vec3 materialDiffuseColor = texture2D(color_Texture, fUVs).rgb;
        //vec3 materialAmbientColor = vec3(0.1, 0.1, 0.1) * materialDiffuseColor;
		vec3 materialAmbientColor = vec3(0.5, 0.5, 0.5) * materialDiffuseColor;
        vec3 materialSpecularColor = vec3(0.3, 0.3, 0.3);

        float distance = length(worldspaceLight - worldspacePos);

        vec3 n = normalize(cameraspaceNorm);
        vec3 l = normalize(cameraspaceLightDir);

        float cosTheta = clamp(dot(n, l), 0, 1);

        vec3 eye = normalize(cameraspaceEyeDir);
        vec3 reflection = reflect(-l, n);

        float cosAlpha = clamp(dot(eye, reflection), 0, 1);

        vec3 color_temp = materialAmbientColor +
                materialDiffuseColor * lightColor * lightPower * cosTheta / (distance * distance) +
                materialSpecularColor * lightColor * lightPower * pow(cosAlpha, 5) / (distance * distance);

		color = vec4(color_temp, 1.0);
		
}