#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNorm;
out vec2 fUVs;

uniform mat4 modelMat;
uniform mat4 projMat;
uniform mat4 viewMat;

out vec3 worldspacePos;
out vec3 cameraspaceNorm;
out vec3 cameraspaceEyeDir;
out vec3 cameraspaceLightDir;

uniform vec3 worldspaceLight;

void main()
{
	fUVs = uv;
	worldNorm = (modelMat * vec4(normal, 0)).xyz;
	gl_Position = (projMat * viewMat * modelMat) * vec4(position, 1);
	
	worldspacePos = (modelMat * vec4(position, 1.0f)).xyz;

	vec3 position_modelspaceCamera = (viewMat * modelMat * vec4(position, 1.0f)).xyz;
    cameraspaceEyeDir = vec3(0, 0, 0) - position_modelspaceCamera;

    vec3 lightPosition_worldspaceCamera = (viewMat * vec4(worldspaceLight, 1.0f)).xyz;
    cameraspaceLightDir = lightPosition_worldspaceCamera + cameraspaceEyeDir;

    cameraspaceNorm = (viewMat * modelMat * vec4(normal, 0.0f)).xyz;
}
