#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNorm;
out vec2 texCoord;//fUVs

uniform mat4 modelMat;
uniform mat4 projMat;
uniform mat4 viewMat;

void main()
{
	gl_Position = projMat * viewMat * modelMat * vec4(position, 1);
	texCoord = uv;
	worldNorm = (modelMat * vec4(normal, 0)).xyz;	
}