#version 330 core

in vec3 position;
in vec3 normal;

out vec3 worldNorm;

uniform mat4 modelMat;
uniform mat4 projMat;
uniform mat4 viewMat;


void main()
{
	gl_Position = projMat * viewMat * modelMat * vec4(position, 1);
	worldNorm = (modelMat * vec4(normal, 0)).xyz;
}